load allData PAR Ta rBLUE rNIR rRED NEE rSWIR dy

EVI   = 2.5*(rNIR - rRED) ./ (rNIR + 6*rRED - 7.5*rBLUE + 1);
LSWI  = (rNIR - rSWIR) ./ (rNIR + rSWIR); 
Wscl  = (1 + LSWI) ./ (1 + max(LSWI));
Pscl  = .5*(1+LSWI);
Prod  = Wscl .* Pscl;

I     =  cell(4,1);
I{1}  = find( (dy>291 | dy<131) & PAR>850 );  
I{2}  = find( (dy>291 | dy<131) & PAR<350 );  
I{3}  = find(  dy>131 & dy<291  & PAR>850 );  
I{4}  = find(  dy>131 & dy<291  & PAR<350 );  

dr    =  cell(4,1);           
dr{1} = 'winter high PAR';    
dr{2} = 'winter low PAR';     
dr{3} = 'summer high PAR';
dr{4} = 'summer low PAR';

sz    =  cell(2,1);	    
sz{1} = 'mid Oct. to mid May (doy\in[291,130])';
sz{2} = 'mid May to mid Oct. (doy\in[131,290])';

%         1   2   3    4     5     6
X    = [ PAR Ta rBLUE rNIR rRED rSWIR  ];
y    = NEE;
Np   = length(X(1,:));
Nt   = length(X(:,1));
Ne   = length(I);        % number of doy epochs
Nmc  = 100;              % MC realization number

load TnPARdependence.mat Prm Net

% get seasonal T grids
Tg = zeros(25,Ne);
dT = [];
for i = 1:Ne
  tg = X(I{i},2);
  tg = sort(tg);
  tg = tg(round(length(tg)*[.025 .975]));
  Tg(:,i) = linspace(tg(1),tg(2),25)'; 
  dT = [ dT diff(Tg(1:2,i)) ];
end
dT = 1.5*dT;
  
Tmin =   0;
Tmax =  40;  % remember: Topt is p(2)

o = ones(25,1);

un  = 'Units';
clr = 'color';
rt  = 'Rotation';
fs  = 'FontSize';
lw  = 'LineWidth';
fw  = 'FontWeight';
nr  = 'normalized';
ha  = 'HorizontalAlignment';

cl  = [ 148 0 211 ; 0 0 210 ; 255 165 0 ; 210 0 0 ; 0 170 0 ]/255;

pn = 'abcdefghijklm';

clf

xp = [ .07  .38  .07 .38 ]; % x of panels
yp = [ .41 .41 .09 .09 ]; % y of panels
  
xe = [ 9 5 9 5 ]; % x of the left of error bars
ye = [ -2 2.5 -21 4.1 ]; % y of the bottom of error bars

ya = [ -3.4 3.3 ; .4 4.9 ; -25.5 -5 ; -2.5 7 ];

for i = 1:Ne

  axes('Position',[xp(i) yp(i) .27 .29])
  
  plot([min(Tg(:))-1 max(Tg(:))+1],[0 0],'-',clr,.7*[1 1 1],lw,.2);  hold on

  % VPRM-based prediction

  % respiration (25 x Nmc)
  r     = o*Prm(:,4)' .* max(Prm(:,6),Tg(:,i)')' + o*Prm(:,5)';
  r     = median(r,2); % (25 x 1)

  % -lambda T_scale (25 x Nmc)
  t   = (max(Tmin,Tg(:,i)) - Tmin) .* (Tg(:,i) - Tmax); 
  t   = t * ones(1,Nmc);
  t   = t ./ ( t - (Tg(:,i)-Prm(:,2)').*(Tg(:,i)-Prm(:,2)') );
  t   = t .* (-Prm(:,1)*ones(1,25))';
  t   = median(t,2);
  
  % PAR factor (nth x Nmc;  recall - PAR0 is p(3))
  f = PAR(I{i}) * ones(1,Nmc);
  f = f ./ (1+PAR(I{i})./Prm(:,3)');

  % W_scale P_Scale EVI PARf (nth x Nmc)
  f  = ((Prod(I{i}).*EVI(I{i})) * ones(1,Nmc)) .* f;  % (nth x Nmc)

  % VPRM Tscale scaled by T bin independent Wscl*Pscl*EVI*PARf
  ts1 = t*median(f(:));

  % VPRM Tscale with Wscl*Pscl*EVI*PARf T bin specific
  ts2 = t;  
  for j = 1:25
    m      = find( Ta(I{i})>(Tg(j,i)-dT(i)) & Ta(I{i})<(Tg(j,i)+dT(i)) );
    fh     = f(m,:);
    m      = ones(length(m),1);
    ts2(j) = ts2(j)*median(fh(:));
  end  
  ts1 = conv(ts1([1 1:25 25]),[1 2 1]/4,'same'); ts1 = ts1(2:26);
  ts2 = conv(ts2([1 1:25 25]),[1 2 1]/4,'same'); ts2 = ts2(2:26);

  % data 
  d           = zeros(25,1);
  ds          = zeros(25,2);
  for j = 1:25
    m       = find( Ta(I{i})>(Tg(j,i)-dT(i)) & Ta(I{i})<(Tg(j,i)+dT(i)) );
    l       = sort(y(I{i}(m)));
    ds(j,:) = l(round(length(l)*[.3 .7]));
    d(j)    = l(round(length(l)* .5    ));
    % plot season/bin data spread whiskers
    plot(Tg([j j],i),ds(j,:),clr,cl(5,:))
    plot(Tg(j,i)+.3*[-1 1],ds(j,1)*[1 1],clr,cl(5,:))
    plot(Tg(j,i)+.3*[-1 1],ds(j,2)*[1 1],clr,cl(5,:))
  end
  d = conv( d([1 1:25 25]  ),[1 2 1] /4,'same'); d       = d(2:26);
  j = conv(ds([1 1:25 25],1),[1 2 1]'/4,'same'); ds(:,1) = j(2:26);
  j = conv(ds([1 1:25 25],2),[1 2 1]'/4,'same'); ds(:,2) = j(2:26);

  % ANN-based NEE prediction
  ann   = zeros(length(I{i}),Nmc);
  for j = 1:Nmc;  ann(:,j) = Net{j}(X(I{i},:)')';  end
  ma    = zeros(25,1);
  for j = 1:25
    m     = find( Ta(I{i})>(Tg(j,i)-dT(i)) & Ta(I{i})<(Tg(j,i)+dT(i)) );
    m     = ann(m,:);
    ma(j) = median(m(:));
  end
  ma = conv(ma([1 1:25 25]),[1 2 1]/4,'same'); ma = ma(2:26);

  % seasonal RMSEs in micromol/(m2 s)
  eV1 = ts1+r-d; eV1 = sqrt(eV1'*eV1/25);
  eV2 = ts2+r-d; eV2 = sqrt(eV2'*eV2/25);
  eN  = ma   -d; eN  = sqrt(eN' *eN /25);
  
  h(1) = plot(Tg(:,i),ts1+r,clr,cl(2,:)); % VPRM NEE w season    -median scaling
  h(2) = plot(Tg(:,i),ts2+r,clr,cl(3,:)); % VPRM NEE w season/bin-median scaling
  h(3) = scatter(Tg(:,i),d,7,cl(5,:),'filled'); % median season/bin observed NEE
  h(4) = plot(Tg(:,i),ma,'k-');      % ANN median NEE

  if i>2;  xlabel('air temperature, ^\circC'); end

  if i==1 | i==3
    ylabel('NEE (C_\uparrow flux), \mumol m^2 s^{-1}')
  end

  d = 1 + (i<3)*.5;
  set(gca,'XLim',[min(Tg(:,i))-d max(Tg(:,i))+d])
  set(gca,'YLim',ya(i,:))
  
  text(.5,.95,dr{i},un,nr,ha,'c')

  j = .03; if i==2; j = .92; end
  text(j,.06,['{\bf' pn(i) '}'],un,nr,fs,17)

  % plot RMSEs
  yr = get(gca,'YLim');
  yr = diff(yr);
  x0 = get(gca,'XLim');
  xr = diff(x0);
  x0 = x0(1)+xr*.07;
  plot(       x0*[1 1],ye(i)+[0 eV1],clr,cl(2,:),lw,2)
  plot(xr*.03+x0*[1 1],ye(i)+[0 eV2],clr,cl(3,:),lw,2)
  plot(xr*.06+x0*[1 1],ye(i)+[0 eN ],clr,  'k'  ,lw,2)
  text(xr*.045+x0,ye(i)-yr*.02,' rmse',ha,'c')

  if i==3
    j = legend(h(1:4),'VPRM_1','VPRM_2','obs.','ANN','Location','NorthEast');
    set(j,'Position',get(j,'Position')+[.002 0 0 0])
  elseif i==2 | i==4
    text(1.04,.5,sz{i*.5},rt,90,un,nr,ha,'c')
  end

end

set(gcf,'PaperPosition',[.2 .2 8.2 10.6])
print -dpdf -r350 -painters TnPARdependence.pdf


  
