if exist('goodPredictorsMore.mat')~=2 

  % the main data, the actually hourly (from HF tower) or pseudo-hrly
  % rez (the sattelite reflectivities), on the same time grid
  load allData PAR NEE Ta r* t
  td = t;

  % add the soil temp predictor (mean of Ts temps in all control plots)
  load ../Data/harvardForestDailySoilTemp
    
  % make the HF soil temp pseudo-hourly resolution
  Tsoil = (Tsoil*ones(1,24))';
  Tsoil = Tsoil(:); % make continuous
  
  % get doy, day-of-year
  t  = datevec(t);
  dy = t(:,1);
  for i = t(1,1):t(end,1)
    j = find(t(:,1)==i);
    dy(j) = j-j(1)+1;
  end
    
  yr = (t(:,1)*ones(1,24))'; yr = yr(:); % year (hrly rez)
  dy = (  dy  *ones(1,24))'; dy = dy(:); % day-of-year (hrly rez)
  hr = [.5:24]'*ones(1,length(dy)/24); hr = hr(:); % half-hours

  ts  = yr + (dy-1+hr/24)./maxdoy(yr);

  % smooth a bit the pseudo-hourly HF soil temp
  i = conv(Tsoil,ones(1,25)/25); 
  Tsoil(5:end-4) = i(17:end-16);
  
  Tsoil = interp1(ts,Tsoil,td);  clear i j t* yr dy hr 
  
  save Tsoil.mat Tsoil
  
  % add the antecedent precip predictor  
  load ../Data/antecedentPrecipPredictor.mat aPp

  %       1   2   3    4     5     6   7    8
  X  = [ PAR Ta rBLUE rNIR rRED rSWIR aPp Tsoil ];
  y  = NEE;
  
  Nt = length(X(:,1));
  Np = length(X(1,:));

  R2  = []; 
  Nmc = 100;
  r2  = zeros(Nmc,1);

  % 1 predictor
  n = 0;
  for i = 1:Np
    clear net
    net = feedforwardnet([6 5 4]);
    net.divideFcn = '';
    net.trainParam.showWindow = false;
    gd = 0;
    while gd<2
      kt = randperm(Nt,round(Nt*.5)); % training set
      kv = find(~ismember(1:Nt,kt )); % validation set
      net  = train(net,X(kt,i)',y(kt)');
      yht  = net(X(kv,i)')';
      gd   = (max(yht)<50) + (min(yht)>-60);
    end
    for j = 1:Nmc
      k    = randperm(length(kv),1e3);
      yh   = y(kv( k));
      ym   = mean(yh );
      yhth = yht(  k );
      SSr  = (yh-yhth)'*(yh-yhth);
      SSt  = (yh-ym  )'*(yh-ym  );
      r2(j)   = 1-SSr/SSt;
    end
    j  = zeros(1,Np);
    j(i) = i;
    R2 = [ R2 ; j mean(r2) std(r2) 1 ]; 
  end  
  n   = length(R2(:,1));
  disp(R2)
  disp('------------ end of 1 predictor ------------')  

  % ALL 2-predictor combos
  for i = 1:Np-1
    for m = i+1:Np
      clear net
      net = feedforwardnet([6 5 4]);
      net.divideFcn = '';
      net.trainParam.showWindow = false;
      gd = 0;
      while gd<2
	kt = randperm(Nt,round(Nt*.5)); % training set
	kv = find(~ismember(1:Nt,kt )); % validation set
	net  = train(net,X(kt,[i m])',y(kt)');
	yht  = net(X(kv,[i m])')';
	gd   = (max(yht)<50) + (min(yht)>-60);
      end
      for j = 1:Nmc
	k    = randperm(length(kv),1e3);
	yh   = y(kv( k));
	ym   = mean(yh );
	yhth = yht(  k );
	SSr  = (yh-yhth)'*(yh-yhth);
	SSt  = (yh-ym  )'*(yh-ym  );
	r2(j)   = 1-SSr/SSt;
      end
      j  = zeros(1,Np);
      j([i m]) = [i m];
      R2 = [ R2 ; j mean(r2) std(r2) 2 ]; 
    end  
  end  
  n   = length(R2(:,1));
  disp(R2)
  disp('------------ end of 2 predictors ------------')  

  % ALL 3-predictor combos
  for i = 1:Np-2
    for m = i+1:Np-1
      for l = m+1:Np
	clear net
	net = feedforwardnet([6 5 4]);
	net.divideFcn = '';
	net.trainParam.showWindow = false;
	gd = 0;
	while gd<2
	  kt = randperm(Nt,round(Nt*.5)); % training set
	  kv = find(~ismember(1:Nt,kt )); % validation set
	  net  = train(net,X(kt,[i m l])',y(kt)');
	  yht  = net(X(kv,[i m l])')';
	  gd   = (max(yht)<50) + (min(yht)>-60);
	end
	for j = 1:Nmc
	  k    = randperm(length(kv),1e3);
	  yh   = y(kv( k));
	  ym   = mean(yh );
	  yhth = yht(  k );
	  SSr  = (yh-yhth)'*(yh-yhth);
	  SSt  = (yh-ym  )'*(yh-ym  );
	  r2(j)   = 1-SSr/SSt;
	end
	j  = zeros(1,Np);
	j([i m l]) = [i m l];
	R2 = [ R2 ; j mean(r2) std(r2) 3 ]; 
      end  
    end  
  end  
  n   = length(R2(:,1));
  disp(R2)
  disp('------------ end of 3 predictors ------------')  

  % ALL 4-predictor combos
  for i = 1:Np-3
    for m = i+1:Np-2
      for l = m+1:Np-1
	for q = l+1:Np
	  clear net
	  net = feedforwardnet([6 5 4]);
	  net.divideFcn = '';
	  net.trainParam.showWindow = false;
	  gd = 0;
	  while gd<2
	    kt = randperm(Nt,round(Nt*.5)); % training set
	    kv = find(~ismember(1:Nt,kt )); % validation set
	    net  = train(net,X(kt,[i m l q])',y(kt)');
	    yht  = net(X(kv,[i m l q])')';
	    gd   = (max(yht)<50) + (min(yht)>-60);
	  end
	  for j = 1:Nmc
	    k    = randperm(length(kv),1e3);
	    yh   = y(kv( k));
	    ym   = mean(yh );
	    yhth = yht(  k );
	    SSr  = (yh-yhth)'*(yh-yhth);
	    SSt  = (yh-ym  )'*(yh-ym  );
	    r2(j)   = 1-SSr/SSt;
	  end
	  j  = zeros(1,Np);
	  j([i m l q]) = [i m l q];
	  R2 = [ R2 ; j mean(r2) std(r2) 4 ]; 
	end  
      end  
    end  
  end  
  n   = length(R2(:,1));
  disp(R2)
  disp('------------ end of 4 predictors ------------')  

  % ALL 5-predictor combos
  for i = 1:Np-4
    for m = i+1:Np-3
      for l = m+1:Np-2
	for q = l+1:Np-1	
	  for r = q+1:Np
	    clear net
	    net = feedforwardnet([6 5 4]);
	    net.divideFcn = '';
	    net.trainParam.showWindow = false;
	    gd = 0;
	    while gd<2
	      kt = randperm(Nt,round(Nt*.5)); % training set
	      kv = find(~ismember(1:Nt,kt )); % validation set
	      net  = train(net,X(kt,[i m l q r])',y(kt)');
	      yht  = net(X(kv,[i m l q r])')';
	      gd   = (max(yht)<50) + (min(yht)>-60);
	    end
	    for j = 1:Nmc
	      k    = randperm(length(kv),1e3);
	      yh   = y(kv( k));
	      ym   = mean(yh );
	      yhth = yht(  k );
	      SSr  = (yh-yhth)'*(yh-yhth);
	      SSt  = (yh-ym  )'*(yh-ym  );
	      r2(j)   = 1-SSr/SSt;
	    end
	    j  = zeros(1,Np);
	    j([i m l q r]) = [i m l q r];
	    R2 = [ R2 ; j mean(r2) std(r2) 5 ]; 
	  end  
	end  
      end  
    end  
  end  
  n   = length(R2(:,1));
  disp(R2)
  disp('------------ end of 5 predictors ------------')  

  % ALL 6-predictor combos
  for i = 1:Np-5
    for m = i+1:Np-4
      for l = m+1:Np-3
	for q = l+1:Np-2	
	  for r = q+1:Np-1
	    for s = r+1:Np
	      clear net
	      net = feedforwardnet([6 5 4]);
	      net.divideFcn = '';
	      net.trainParam.showWindow = false;
	      gd = 0;
	      while gd<2
		kt = randperm(Nt,round(Nt*.5)); % training set
		kv = find(~ismember(1:Nt,kt )); % validation set
		net  = train(net,X(kt,[i m l q r s])',y(kt)');
		yht  = net(X(kv,[i m l q r s])')';
		gd   = (max(yht)<50) + (min(yht)>-60);
	      end
	      for j = 1:Nmc
		k    = randperm(length(kv),1e3);
		yh   = y(kv( k));
		ym   = mean(yh );
		yhth = yht(  k );
		SSr  = (yh-yhth)'*(yh-yhth);
		SSt  = (yh-ym  )'*(yh-ym  );
		r2(j)   = 1-SSr/SSt;
	      end
	      j  = zeros(1,Np);
	      j([i m l q r s]) = [i m l q r s];
	      R2 = [ R2 ; j mean(r2) std(r2) 6 ]; 
	      disp(R2(end,:))
	    end  
	  end  
	end  
      end  
    end  
  end
  disp(R2)
  disp('------------ end of 6 predictors ------------')  

  save goodPredictorsMore.mat R2
  
end

load allData PAR NEE Ta r* 
load Tsoil.mat Tsoil
load ../Data/antecedentPrecipPredictor.mat aPp

%       1   2   3    4     5     6   7    8
X  = [ PAR Ta rBLUE rNIR rRED rSWIR aPp Tsoil ];
y  = NEE;
  
Nt = length(X(:,1));
Np = length(X(1,:));

Nmc = 100;
r2  = zeros(Nmc,1);

load goodPredictorsMore.mat R2

if isempty(find(R2(:,end)==7))

  % ALL 7-predictor combos
  for i = 1:Np-6
    for m = i+1:Np-5
      for l = m+1:Np-4
	for q = l+1:Np-3	
	  for r = q+1:Np-2
	    for s = r+1:Np-1
	      for n = s+1:Np
		clear net
		net = feedforwardnet([6 5 4]);
		net.divideFcn = '';
		net.trainParam.showWindow = false;
		gd = 0;
		while gd<2
		  kt = randperm(Nt,round(Nt*.5)); % training set
		  kv = find(~ismember(1:Nt,kt )); % validation set
		  net  = train(net,X(kt,[i m l q r s n])',y(kt)');
		  yht  = net(X(kv,[i m l q r s n])')';
		  gd   = (max(yht)<50) + (min(yht)>-60);
		end
		for j = 1:Nmc
		  k    = randperm(length(kv),1e3);
		  yh   = y(kv( k));
		  ym   = mean(yh );
		  yhth = yht(  k );
		  SSr  = (yh-yhth)'*(yh-yhth);
		  SSt  = (yh-ym  )'*(yh-ym  );
		  r2(j)   = 1-SSr/SSt;
		end
		j  = zeros(1,Np);
		j([i m l q r s n]) = [i m l q r s n];
		R2 = [ R2 ; j mean(r2) std(r2) 7 ]; 
		disp(R2(end,:))
	      end  
	    end  
	  end  
	end  
      end  
    end
  end
  disp(R2)
  disp('------------ end of 7 predictors ------------')  

  save goodPredictorsMore.mat R2

end

% load the nonLineReg cross validation prediction
load totalCuptake yht kv; yht = yht(:,1); NEE = NEE(kv); clear kv

NLR = zeros(200,1);
for i = 1:200
  j   = randperm(length(yht),1e4);
  yh  = yht(j);
  e   = yh - NEE(j);
  SSr = e'*e;
  SSt = ( NEE(j)-mean(NEE(j)) )'*( NEE(j)-mean(NEE(j)) );
  NLR(i) = 1-SSr/SSt;
end
NLR = [ mean(NLR) std(NLR) ];

load goodPredictorsMore

cl = [ 0 0 0 ; 0 .5 0 ; .5 0 0 ; [ 32 178 170 ]/255 ; 0 0 .5 ];
cl = [ cl ; [ 139 0 139 ; 255 69 0 ]/255 ]; 
  
gr = .85*[1 1 1];
g2 = .75*[1 1 1];

clf; x0 = 1.025; 
vr    = cell(8,1);
vr{1} = 'PAR';
vr{2} = '{\itT}';
vr{3} = 'rBLUE';
vr{4} = 'rNIR';
vr{5} = 'rRED';
vr{6} = 'rSWIR';
vr{7} = '{\itp}_{ca}';
vr{8} = '{\itT}_{soil}';

ha  = 'HorizontalAlignment';
ms  = 'MarkerSize';
nr  = 'normalized';
ec  = 'EdgeColor';
lw  = 'LineWidth';
fs  = 'FontSize';
clr = 'Color';
un  = 'Units';

ni = []; for i=1:8; j = find(R2(:,11)==i); ni = [ ni length(j) ]; end
ni = max(ni)+1;

axes('Position',[.08 .6 .6 .31])
fill([0 0 2 2],[.755 .832 .832 .755],gr,'EdgeColor',gr); hold on
fill([0 0 2 2],NLR(1)+NLR(2)*[-1 1 1 -1],g2,'EdgeColor',g2)
for i = 1:R2(end,11) % number of predictors (7)
  j  = find(R2(:,11)==i);
  n  = length(j);
  [r2,k] = sort(R2(j,9));
  lr = length(find(r2>(NLR(1)+NLR(2)*.5)));
  s  = R2(j(k),10);
  x  = x0+.11*[1:n]/n;
  ph = max( R2(j(k),1:8), [] , 2) ;
  plot(x,r2,'-',clr,cl(i,:))
  ml = 0;
  nl = 0;
  for l = 1:n
    plot(x(l)*[1 1],r2(l)+s(l)*[-1 1],'-',lw,.2,clr,cl(i,:))
    plot(x(l)+.003*[-1 1],r2(l)+s(l)*[1 1],'-',lw,.2,clr,cl(i,:))
    plot(x(l)+.003*[-1 1],r2(l)-s(l)*[1 1],'-',lw,.2,clr,cl(i,:))
    if ph(l)<7
      plot(x(l),r2(l),'s',lw,.2,clr,cl(i,:),ms,3); 
      ml = ml + 1; 
      if r2(l)>(NLR(1)+NLR(2)*.5); nl = nl + 1; end
    end
    if i==1
      text(x(l)-.003,r2(l)+s(l)+.02,int2str(R2(j(k(l)),j(k(l)))))
    end
  end
  if i==1
    ylabel('cross validate {\itR}^2 NEE prediction skill')
    text(x(2),r2(2)-.04,[ '{\itN}_p = ' int2str(i)],clr,cl(i,:))
  elseif i==2 
    text(x(2)+.005,r2(2),[ '{\itN}_p = ' int2str(i)],clr,cl(i,:))
  elseif i>2 
    text(x(1)-.02,r2(1)-.04,[ '{\itN}_p = ' int2str(i)],clr,cl(i,:))
  end
  x0 = x0+.0749;
end
for i = 1:max(R2(:,8)) % number of predictors (8)
  text(.015,.94-i*.06,[ int2str(i) '. ' vr{i}],un,nr)
end
axis([ 1.032 1.59 -.01 .834])
set(gca,'XTick',[])
text(.5,-.04,'skill-sorted predictor combinations',ha,'c',un,nr)
text(.96,.05,'{\bfa}',fs,16,un,nr)

RnS = [];
axes('Position',[.73 .607 .19 .28])
fill([0 0 9 9],NLR(1)+NLR(2)*[-1 1 1 -1],g2,'EdgeColor',g2); hold on
for i = 3:R2(end,11) % number of predictors
  j  = find(R2(:,11)==i);
  [r2,k] = sort(R2(j,9),'descend');
  r2  = r2(1:2);
  k   = k(1:2);
  s   = R2(j(k),10);
  RnS = [ RnS ; r2(1) s(1) ; r2(2) s(2) ];
  for m = 1:2
    pr  = R2(j(k(m)),1:8);
    pr  = pr(find(pr));
    xh = i+.15-(m==2)*.3;
    scatter(xh,r2(m),12,cl(i,:),'filled')
    plot([1 1]*xh,r2(m)+s(m)*[-1 1],'-',clr,cl(i,:))
    plot(xh+.12*[-1 1],r2(m)+s(m)*[1 1],'-',clr,cl(i,:))
    plot(xh+.12*[-1 1],r2(m)-s(m)*[1 1],'-',clr,cl(i,:))
    tx = [];
    for o = 1:length(pr)
      tx = [ tx int2str(pr(o)) ',' ];
    end
    tx = tx(1:end-1);
    if r2(m)<.8; yh = r2(m)+s(m)+.0005; h = 'l'; 
    else; yh = r2(m)-s(m)-.0005; h = 'r'; end
    text(xh,yh,tx,'Rotation',90,ha,h,fs,8)
  end
  axis([2.4 7.6 .755 .833])
  set(gca,'XTick',3:6,'XTickLabel',[],'YMinorTick','on')
  text(.5,1.077,'top  multi-',un,nr,ha,'c')
  tx = '-predictor skills';
  text(.5,1.027,tx,un,nr,ha,'c')
end
j = 'number of predictors';
text(0.5,-.08,j,un,nr,ha,'c')
text(2.9,.7525,'3')
text(3.9,.7525,'4')
text(4.9,.7525,'5')
text(5.9,.7525,'6')
text(6.9,.7525,'7')
text(-.11,1.03,'{\bfb}',fs,16,un,nr)

% test for significance of differences in the top R2s
Nmc = 100; % make sure it's the one used above, in case this ever changes
for i = 3:2:length(RnS(:,1))
  s  = sqrt( (Nmc-1)*(RnS(i-1,2)^2 + RnS(i,2)^2)/(2*Nmc-2) );
  se = s * sqrt( 2/Nmc );
  t  = abs( RnS(i-1,1) - RnS(i,1) )/se;
  p  = 2-2*tcdf(t,2*Nmc-2);
  j = '';
  if p<.05; j = '*'  ;
    if p<.01; j = [ j '*' ]; 
      if p<.005; j = [ j '*' ]; 
	if p<.001; j = [ j '*' ]; 
	end 
      end 
    end 
  end 
  text((i+1)*.5+1.5,.798,j,'Rotation',90)
end
  
set(gcf,'PaperPosition',[.2 .2 8.2 10.6])
print -dpdf -r350 -painters goodPredictorsMore.pdf

% find common predictors in winning combinations
G = [ ];
for i = 1:7
  j = find(R2(:,11)==i                  );
  k = find(R2(:,11)==i & R2(:,9)>NLR(1) );
  p = R2(k,1:8);
  p = p(:);
  p = p(find(p));
  g = [ ];
  for l = 1:8
    g = [ g length(find(p==l)) ];
  end
  G = [ G ; i length(j) length(k) -9 g ];
end
G = [ G ; -9 sum(G(:,2:3)) -9 sum(G(:,5:12)) ];
disp(G)