load ../Data/antecedentPrecipPredictor.mat aPp
load allData.mat PAR Ta rBLUE rNIR rRED NEE rSWIR dy
load Tsoil.mat Tsoil
load('JacobianHessian.mat','Prm','Net')

I{1} = find( dy>334 | dy< 62 ); % DJF
I{2} = find( dy>104 & dy<152 ); % Apr15--May31
I{3} = find( dy>152 & dy<245 ); % JJA

Tg = -7:2:31;
NT = length(Tg);

Nmc = length(Net);

%        1   2   3    4     5     6   7    8
X    = [ PAR Ta rBLUE rNIR rRED rSWIR aPp Tsoil ];

Dndpd = zeros(3,NT,Nmc)*nan;
Dndpv = zeros(3,NT,Nmc)*nan;
Dndpn = zeros(3,NT,Nmc)*nan;
Nd    = zeros(3,NT    )    ;

kt    = zeros(NT,1);

for i = 1:NT
  for s = 1:3
  
    j = find( Ta(I{s})>=(Tg(i)-1.5) & Ta(I{s})<=(Tg(i)+1.5) );
    Nd(s,i) = length(j);

    if Nd(s,i)>150

      Xh = X(I{s}(j),:);
      Xh = [ Xh(:,1) ones(Nd(s,i),1)*median(Xh(:,2:8)) ];
      
      kt(i) = 1;
      
      p = PAR(I{s}(j));

      yhtv = [];
      yhtn = [];
      for l = 1:Nmc
	yhtv = [ yhtv NEEnonLinReg(Prm(l,:),Xh) ]; 
	yhtn = [ yhtn Net{l}(Xh')' ];
      end
      yhtv = median(yhtv,2);
      yhtn = median(yhtn,2);

      for l = 1:Nmc
	m = randperm(Nd(s,i),round(Nd(s,i)*.9));
	A = [ ones(length(m),1) p(m) ];
	x = A\NEE(I{s}(j(m)));	Dndpd(s,i,l) = x(2); % data
	x = A\yhtv(m);	        Dndpv(s,i,l) = x(2); % VPRM
	x = A\yhtn(m);	        Dndpn(s,i,l) = x(2); % aANN
      end
      % data
      n = squeeze(Dndpd(s,i,:));
      l = find(~isnan(n));
      n = sort(n(l));
      m = median(n(l));
      Dndpd(s,i,1) = m; 
      Dndpd(s,i,2) = n( 1 )-m; 
      Dndpd(s,i,3) = n(end)-m;
      % VPRM
      n = squeeze(Dndpv(s,i,:));
      l = find(~isnan(n));
      n = sort(n(l));
      m = median(n(l));
      Dndpv(s,i,1) = m; 
      Dndpv(s,i,2) = n( 1 )-m; 
      Dndpv(s,i,3) = n(end)-m;
      % VPRM
      n = squeeze(Dndpn(s,i,:));
      l = find(~isnan(n));
      n = sort(n(l));
      m = median(n(l));
      Dndpn(s,i,1) = m; 
      Dndpn(s,i,2) = n( 1 )-m; 
      Dndpn(s,i,3) = n(end)-m;
    end
  
  end
end
kt    = find(kt>0);
Dndpd = Dndpd(:,kt,1:3)*1e3;
Dndpv = Dndpv(:,kt,1:3)*1e3; 
Dndpn = Dndpn(:,kt,1:3)*1e3;  clear Prm Net
Tg    = Tg(kt);

clf

ax = [ Tg(1)-.9 Tg(end)+.9 ];

axes('Position',[.08 .69 .3 .3]) 
plot([-20 60],[0 0],'-','Color',.8*[1 1 1]); hold on 
m = errorbar(Tg,Dndpd(1,:,1),Dndpd(1,:,2),Dndpd(1,:,3),'g-'); m.CapSize = 2;
m = errorbar(Tg,Dndpv(1,:,1),Dndpv(1,:,2),Dndpv(1,:,3),'b-'); m.CapSize = 2;
m = errorbar(Tg,Dndpn(1,:,1),Dndpn(1,:,2),Dndpn(1,:,3),'r-'); m.CapSize = 2;
m1 = Dndpd(1,:,1) + Dndpd(1,:,2);
m2 = Dndpv(1,:,1) + Dndpv(1,:,2);
m3 = Dndpn(1,:,1) + Dndpn(1,:,2); m = [     m1(:) ; m2(:) ; m3(:) ];
m1 = Dndpd(1,:,1) + Dndpd(1,:,3);
m2 = Dndpv(1,:,1) + Dndpv(1,:,3);
m3 = Dndpn(1,:,1) + Dndpn(1,:,3); n = [ m ; m1(:) ; m2(:) ; m3(:) ];
axis([ax min(n)-.2 max(n)+.2])
set(gca,'XTick',-10:5:35)
m = max(find(~isnan(squeeze(Dndpd(1,:,1)))));
text(Tg(m)+1,Dndpd(1,m,1),'tower data','Color','g')
text(Tg(m)+1,Dndpv(1,m,1),'VPRM','Color','b')
text(Tg(m)+1,Dndpn(1,m,1),'aANN','Color','r')
ev = squeeze(Dndpv(1,:,1) - Dndpd(1,:,1));  ev = ev(find(~isnan(ev)));
en = squeeze(Dndpn(1,:,1) - Dndpd(1,:,1));  en = en(find(~isnan(en)));
ev = sprintf('%3.1f',sqrt(ev*ev'/length(ev)));
en = sprintf('%3.1f',sqrt(en*en'/length(en)));
text(.03,.47,'RMSD:','Units','normalized')
text(.03,.38,ev,'Color','b','Units','normalized')
text(.03,.29,en,'Color','r','Units','normalized')
text(.03,.08,'{\bfa}','FontSize',16,'Units','normalized')
text(.98,.05,'DJF','Units','normalized','HorizontalAlignment','r')

axes('Position',[.08 .385 .3 .3]) 
plot([-20 60],[0 0],'-','Color',.8*[1 1 1]); hold on 
m = errorbar(Tg,Dndpd(2,:,1),Dndpd(2,:,2),Dndpd(2,:,3),'g-'); m.CapSize = 2;
m = errorbar(Tg,Dndpv(2,:,1),Dndpv(2,:,2),Dndpv(2,:,3),'b-'); m.CapSize = 2;
m = errorbar(Tg,Dndpn(2,:,1),Dndpn(2,:,2),Dndpn(2,:,3),'r-'); m.CapSize = 2;
m1 = Dndpd(2,:,1) + Dndpd(2,:,2);
m2 = Dndpv(2,:,1) + Dndpv(2,:,2);
m3 = Dndpn(2,:,1) + Dndpn(2,:,2); m = [     m1(:) ; m2(:) ; m3(:) ];
m1 = Dndpd(2,:,1) + Dndpd(2,:,3);
m2 = Dndpv(2,:,1) + Dndpv(2,:,3);
m3 = Dndpn(2,:,1) + Dndpn(2,:,3); n = [ m ; m1(:) ; m2(:) ; m3(:) ];
axis([ax min(n)-.4 max(n)+.4])
text(.03,.08,'{\bfb}','FontSize',16,'Units','normalized')
ev = squeeze(Dndpv(2,:,1) - Dndpd(2,:,1));  ev = ev(find(~isnan(ev)));
en = squeeze(Dndpn(2,:,1) - Dndpd(2,:,1));  en = en(find(~isnan(en)));
ev = sprintf('%3.1f',sqrt(ev*ev'/length(ev)));
en = sprintf('%3.1f',sqrt(en*en'/length(en)));
text(.03,.47,'RMSD:','Units','normalized')
text(.03,.38,ev,'Color','b','Units','normalized')
text(.03,.29,en,'Color','r','Units','normalized')
text(.98,.93,'Apr15-May31','Units','normalized','HorizontalAlignment','r')
set(gca,'XTick',-10:5:35)
ylabel('\deltaNEE/\deltaPAR, mmol mol^{-1}')

axes('Position',[.08 .08 .3 .3]) 
plot([-20 60],[0 0],'-','Color',.8*[1 1 1]); hold on 
m = errorbar(Tg,Dndpd(3,:,1),Dndpd(3,:,2),Dndpd(3,:,3),'g-'); m.CapSize = 2;
m = errorbar(Tg,Dndpv(3,:,1),Dndpv(3,:,2),Dndpv(3,:,3),'b-'); m.CapSize = 2;
m = errorbar(Tg,Dndpn(3,:,1),Dndpn(3,:,2),Dndpn(3,:,3),'r-'); m.CapSize = 2;
xlabel('{\itT}_{air}, ^\circC')
m1 = Dndpd(3,:,1) + Dndpd(3,:,2);
m2 = Dndpv(3,:,1) + Dndpv(3,:,2);
m3 = Dndpn(3,:,1) + Dndpn(3,:,2); m = [     m1(:) ; m2(:) ; m3(:) ];
m1 = Dndpd(3,:,1) + Dndpd(3,:,3);
m2 = Dndpv(3,:,1) + Dndpv(3,:,3);
m3 = Dndpn(3,:,1) + Dndpn(3,:,3); n = [ m ; m1(:) ; m2(:) ; m3(:) ];
axis([ax min(n)-.5 max(n)+.5])
text(.03,.08,'{\bfc}','FontSize',16,'Units','normalized')
ev = squeeze(Dndpv(3,:,1) - Dndpd(3,:,1));  ev = ev(find(~isnan(ev)));
en = squeeze(Dndpn(3,:,1) - Dndpd(3,:,1));  en = en(find(~isnan(en)));
ev = sprintf('%3.1f',sqrt(ev*ev'/length(ev)));
en = sprintf('%3.1f',sqrt(en*en'/length(en)));
text(.03,.47,'RMSD:','Units','normalized')
text(.03,.38,ev,'Color','b','Units','normalized')
text(.03,.29,en,'Color','r','Units','normalized')
text(.98,.05,'JJA','Units','normalized','HorizontalAlignment','r')
set(gca,'XTick',-10:5:35)

set(gcf,'PaperPosition','default')
print -dpdf -r350 -painters dNEEdPAR.pdf
